It's not a Bug, It's a Feature!
Time Limit: 5000MS   Memory Limit: 30000K
Total Submissions: 1231   Accepted: 466

Description

It is a curious fact that consumers buying a new software product generally do not expect the software to be bug-free. Can you imagine buying a car whose steering wheel only turns to the right? Or a CD-player that plays only CDs with country music on them? Probably not. But for software systems it seems to be acceptable if they do not perform as they should do. In fact, many software companies have adopted the habit of sending out patches to fix bugs every few weeks after a new product is released (and even charging money for the patches).
Tinyware Inc. is one of those companies. After releasing a new word processing software this summer, they have been producing patches ever since. Only this weekend they have realized a big problem with the patches they released. While all patches fix some bugs, they often rely on other bugs to be present to be installed. This happens because to fix one bug, the patches exploit the special behavior of the program due to another bug.

More formally, the situation looks like this. Tinyware has found a total of n bugs B = {b1, b2, ..., bn} in their software. And they have released m patches p1, p2, ..., pm. To apply patch pi to the software, the bugs Bi
+ in B have to be present in the software, and the bugs Bi
- in B must be absent (of course Bi
+ ∩ Bi
- = Φ). The patch then fixes the bugs Fi
- in B (if they have been present) and introduces the new bugs Fi
+ in B (where, again, Fi
+ ∩ Fi
- = Φ).

Tinyware's problem is a simple one. Given the original version of their software, which contains all the bugs in B, it is possible to apply a sequence of patches to the software which results in a bug- free version of the software? And if so, assuming that every patch takes a certain time to apply, how long does the fastest sequence take?

Input

The input contains several product descriptions. Each description starts with a line containing two integers n and m, the number of bugs and patches, respectively. These values satisfy 1 <= n <= 20 and 1 <= m <= 100. This is followed by m lines describing the m patches in order. Each line contains an integer, the time in seconds it takes to apply the patch, and two strings of n characters each.

The first of these strings describes the bugs that have to be present or absent before the patch can be applied. The i-th position of that string is a ``+'' if bug bi has to be present, a ``-'' if bug bi has to be absent, and a `` 0'' if it doesn't matter whether the bug is present or not.

The second string describes which bugs are fixed and introduced by the patch. The i-th position of that string is a ``+'' if bug bi is introduced by the patch, a ``-'' if bug bi is removed by the patch (if it was present), and a ``0'' if bug bi is not affected by the patch (if it was present before, it still is, if it wasn't, is still isn't).

The input is terminated by a description starting with n = m = 0. This test case should not be processed.

Output

For each product description first output the number of the product. Then output whether there is a sequence of patches that removes all bugs from a product that has all n bugs. Note that in such a sequence a patch may be used multiple times. If there is such a sequence, output the time taken by the fastest sequence in the format shown in the sample output. If there is no such sequence, output ``Bugs cannot be fixed.''.

Print a blank line after each test case.

Sample Input

3 3
1 000 00-
1 00- 0-+
2 0-- -++
4 1
7 0-0+ ----
0 0

Sample Output

Product 1
Fastest sequence takes 8 seconds. Product 2
Bugs cannot be fixed.

Source

好坑的一题 ,刚开始没有考虑到不同走的方法是不等价的,所以错了很多次,用个优先队列就可以了,直接上代码,但不知道,那些0m的是怎么搞的,我把能优化的都优化了啊,像什么二进制,我估计还有什么好的优化方法吧,等以后再看看
#include<stdio.h>
#include<iostream>
#include<string.h>
#include<queue>
using namespace std;
int n,m,time[200],before[2][200],after[2][200],visit[2000000];
struct bugtree{int time ,bugnum;
bool operator <(const bugtree a)const //重载比较函数,为下面队作准备,也可以在外面
{
if(time>a.time)//这里是大于号,要小心这里和下面优先队列的排列顺序是有很大关系的!
return true;
else
return false ;
} };
bool bugcan(int i,bugtree f)//判断是否符合第m种的操作
{
int ignore;
ignore=f.bugnum&(~before[0][i]);//把不用考虑的全部置成0其它的不变
// printf("%d ignore\n",ignore);
if(ignore==before[1][i])//如果在不能有的位置上有1,就要返回假
return true;
return false ;
}
int bfs()
{
int i;
bugtree temp,ss;
priority_queue < bugtree > q;
memset(visit,-1,sizeof(visit));
while(!q.empty())//清空
q.pop();
temp.time=0;
temp.bugnum=(1<<n)-1;
//printf("temp %d\n",temp.bugnum);
visit[temp.bugnum]=temp.time;
q.push(temp);
while(!q.empty())
{
temp=q.top();
q.pop();
if(temp.bugnum==0)
{
return temp.time;//找到最小值,在这里判断会找到最小值
}
for(i=0;i<m;i++)
{ if(bugcan(i,temp))//满足第m条件
{ ss.time=temp.time+time[i];
ss.bugnum=(temp.bugnum|after[0][i])&after[1][i];
// printf("%d i%d ss\n",i,ss.bugnum);
if((visit[ss.bugnum]<0)||(ss.time<visit[ss.bugnum]))//未访问过,或者,时间更少,都加入队列
{
// printf(" i%d %di\n",i,ss.bugnum);
visit[ss.bugnum]=ss.time;
q.push(ss);
} }
}
}
return -1;//没有搜到
}
int main()
{
int i,j,re,tcase;
char c;tcase=1;char strtemp[200];
while(scanf("%d%d",&n,&m)!=EOF)
{ if(n==0&&m==0)
break;
for(i=0;i<m;i++ )
{
scanf("%d",&time[i]);
getchar();
before[0][i]=0;
before[1][i]=0;
after[0][i]=0;
after[1][i]=0;
for( j=0;j<n;j++)//是否能操作,如果把两者分开了,就可以全部用二进制进行操作,对于后面的搜索是非常有用的
{
c=getchar();
before[0][i]=before[0][i]<<1;//是第i个,不能用j
before[1][i]=before[1][i]<<1;//在每一个循环都要左移,为了记录每一个位置的相应的变化
if(c=='0')
{
before[0][i]=before[0][i]|1;//用1来表示是进行操作 }
else if(c=='-')//要将-和0分开,这是两种不同的操作
{
// before[1][i]=before[1][i];//用1来标记是否要这个条件
}
else if(c=='+')
{
before[1][i]=before[1][i]|1;
} }
getchar();//将中间的空格号收掉
for( j=0;j<n;j++)//改掉bug
{
c=getchar();
if(c=='+')
{
after[0][i]=after[0][i]<<1|1;//加用1或,不用管的地方用0
after[1][i]=after[1][i]<<1|1;
}
else if(c=='-')
{
after[0][i]=after[0][i]<<1;
after[1][i]=after[1][i]<<1;//减用0且,不用管的地方用1
}
else if(c=='0')
{
after[0][i]=after[0][i]<<1;
after[1][i]=(after[1][i]<<1)|1;
} }
gets(strtemp);//将最后的回车收掉 }
//printf("%d %dafter \n",after[0][0],after[1][0]);
re=bfs();
printf("Product %d\n",tcase++);
if(re!=-1)
{
printf("Fastest sequence takes %d seconds.\n\n",re);
}
else{ printf("Bugs cannot be fixed.\n\n");
} } return 0;
}

poj1483 It's not a Bug, It's a Feature!的更多相关文章

  1. [有意思]The IT workers of Star Wars -- That's not a bug. It's a feature

    Yeah, that Artoo is kinda mouthy... ... now select, "restore to factory settings." That'll ...

  2. 【最短路】【位运算】It's not a Bug, it's a Feature!

    [Uva658] It's not a Bug, it's a Feature! 题目略 UVA658 Problem PDF上有 试题分析:     本题可以看到:有<=20个潜在的BUG,那 ...

  3. UVA 658 It's not a Bug, it's a Feature! (最短路,经典)

    题意:有n个bug,有m个补丁,每个补丁有一定的要求(比如某个bug必须存在,某个必须不存在,某些无所谓等等),打完出来后bug还可能变多了呢.但是打补丁是需要时间的,每个补丁耗时不同,那么问题来了: ...

  4. UVa 658 (Dijkstra) It's not a Bug, it's a Feature!

    题意: 有n个BUG和m个补丁,每个补丁用一个串表示打补丁前的状态要满足的要求,第二个串表示打完后对补丁的影响,还有打补丁所需要的时间. 求修复所有BUG的最短时间. 分析: 可以用n个二进制位表示这 ...

  5. UVA 658 It's not a Bug, it's a Feature!

    这个题目巧妙之处在于用二进制的每个位1,0分别表示bug的有无,以及实施补丁对相应bug的要求以及实施后的对bug的影响. 软件bug的状态:1表示相应bug仍然存在,0表示已经修复.这样可以将软件的 ...

  6. UVa 658 - It's not a Bug, it's a Feature!(Dijkstra + 隐式图搜索)

    链接: https://uva.onlinejudge.org/index.php?option=com_onlinejudge&Itemid=8&page=show_problem& ...

  7. UVa 658 It's not a Bug, it's a Feature! (状态压缩+Dijstra)

    题意:首先给出n和m,表示有n个bug和m个补丁.一开始存在n个bug,用1表示一个bug存在0表示不存在,所以一开始就是n个1,我们的目的是要消除所有的bug, 所以目标状态就是n个0.对于每个补丁 ...

  8. UVA - 658 It's not a Bug, it's a Feature! (隐式图的最短路,位运算)

    隐式的图搜索,存不下边,所以只有枚举转移就行了,因为bug的存在状态可以用二进制表示,转移的时候判断合法可以用位运算优化, 二进制pre[i][0]表示可以出现的bug,那么u&pre[i][ ...

  9. 洛谷 题解 UVA658 【这不是bug,而是特性 It's not a Bug, it's a Feature!】

    [题意] 补丁在修正\(BUG\)时,有时也会引入新的\(BUG\),假定有\(n(n<=20)\)个潜在\(BUG\),和\(m(m<=100)\)个补丁,每个补丁用两个长度为\(n\) ...

随机推荐

  1. Hibernat之关系的处理一对一处理

    第一步:编写两个pojo,比如一个学生表一个班级表  这里使用注解. 需要 公司表: package com.qcf.pox; import javax.persistence.CascadeType ...

  2. Pki原则

    核心提示: 公开密钥和公开密钥证明书,产生的私钥client要么server证书.加密的公共密钥才能解密私钥文件只.私钥只能解密公开的加密文件.公众认为,它是开放的.所有的人都能够得到它.私人还表明, ...

  3. 用一条SQL语句取出第 m 条到第 n 条记录的方法

    原文:用一条SQL语句取出第 m 条到第 n 条记录的方法   --从Table 表中取出第 m 条到第 n 条的记录:(Not In 版本)       *    FROM Table     id ...

  4. POJ3243 EXT-BSGS算法

    需要解决问题之前,首先要做到POJ2417,我的解决问题的方法:http://blog.csdn.net/wyfcyx_forever/article/details/40538515 如今来看这个问 ...

  5. 使用 C# 进行 Outlook 2003 编程

    原文:使用 C# 进行 Outlook 2003 编程 摘要: 本文介绍了 Microsoft Outlook 2003 对象模型介,并探讨了如何使用 C# 编程语言生成 Outlook 识别的应用程 ...

  6. 为JS字符类型添加trim方法

    JS字符串本身并不没有提供常用的trim方法,我们可以通过修改String原形来添加此方法,我们就可以直接调用此方法了: String.prototype.trim = function(){retu ...

  7. SSH简介

    一.什么是SSH? Secure Shell(缩写为SSH),由IETF的网络工作小组(Network Working Group)所制定:SSH为一项创建在应用层和传输层基础上的安全协议,为计算机上 ...

  8. MVC5系列——布局视图

    MVC5系列——布局视图 目录 系列文章 概述 布局视图 系列文章 [Asp.net MVC]Asp.net MVC5系列——第一个项目 [Asp.net MVC]Asp.net MVC5系列——添加 ...

  9. 谈谈Oracle dba_free_space

    谈谈Oracle dba_free_space 博客分类: ORACLE管理 OracleSQLC#C++C  顾名思义,dba_free_space指的是Oracle还有多少表空间剩余空间,其视图结 ...

  10. Reactive Extensions

    Rx提供了一种新的组织和协调异步事件的方式,极大的简化了代码的编写.Rx最显著的特性是使用可观察集合(Observable Collection)来达到集成异步(composing asynchron ...